# NVDA Unmute (Автовключение звука Windows)

* Автор: Олександр Грищенко
* Версия: 1.5
* Совместимость с NVDA: 2019.3 и более новые версии
* Загрузить [стабільную версию][1]

Слава Украине! Героям слава!!!

Это дополнение проверяет состояние аудиосистемы Windows при запуске NVDA. И, если оказывается, что звук выключен или очень приглушенный, - приложение принудительно включает его.

Одновременно проверяется уровень громкости установленый отдельно для процесса NVDA.

Также дополнение проверяет состояние синтезатора речи. Если возникли проблемы с его инициализацией, выполняются попытки запуска синтезатора, который указан в настройках NVDA.

Присутствует дополнительная возможность проверять на какое аудио устройство выводится звук NVDA. И, если это устройство отличается от устройства по умолчанию, - вывод автоматически переключается на аудио-устройство, установленное в системе как основное.

Примечание: Если звуковой сигнал дополнения всегда воспроизводится, даже если уровень громкости NVDA находится на должном уровне. То есть дополнение переключает вывод звука на основное аудио-устройство каждый раз при запуске NVDA.

Это обычно происходит, когда устройство вывода звука в настройках NVDA отличается от устройства вывода по умолчанию или "Microsoft Sound Mapper".

Такое поведение можно легко изменить одним из следующих способов:

1. После перезапуска NVDA просто сохраните текущую конфигурацию с помощью комбинации клавиш NVDA+Ctrl+C. Аудио-устройство по умолчанию будет сохранено в настройках NVDA, и переключения не будет происходить при каждом запуске.
2. Если вы не хотите менять конфигурацию NVDA - просто отключите функцию переключения звукового устройства в панели настроек дополнения.

## Диалоговое окно настроек дополнения
Чтобы открыть панель настроек дополнения, выполните следующие действия:

* Нажмите NVDA+N, чтобы открыть меню NVDA.
* Далее перейдите к подменю "Параметры" -> "Настройки...", и в списке категорий найдите и откройте "Автовключение звука Windows".

Это все, теперь пользуясь клавишей Tab можно переходить между параметрами дополнения.

В диалоговом окне настроек дополнения доступны следующие параметры:

1. Первый слайдер в диалоговом окне настроек дополнения позволяет указать уровень громкости звука Windows, который будет установлен при запуске NVDA, если предварительно звук был выключен или его уровень был слишком низок.

2. Минимальный уровень громкости Windows, при котором будет применяться процедура увеличения звука. Этот слайдер позволяет настроить уровень чувствительности дополнения.

    Если уровень громкости снизится до величины, которая меньше указаного здесь значения, то при следующем запуске NVDA громкость будет увеличена.

    Иначе, если уровень громкости останется выше, чем указаное здесь значение, то при перезапуске NVDA его уровень меняться не будет.

    И, конечно, если звук ранее был выключен, при перезапуске дополнение все равно включит его в любом случае.

3. Следующий флажок позволяет включить повторную инициализацию драйвера голосового синтезатора.

    Эта процедура будет запускаться только в том случае, когда при старте NVDA будет обнаружено, что драйвер синтезатора голоса не был инициализирован.

4. В этом поле можно указать количество попыток повторной инициализации драйвера. Попытки выполняются циклически с интервалом в 1 секунду. Значение 0 означает, что попытки будут выполняться бесконечно аж до успешного завершения процедуры.

5. Опция "Переключать вывод звука NVDA на аудио-устройство по умолчанию" позволяет при запуске проверить на какое аудио устройство выводится звук NVDA. И, если это устройство отличается от устройства по умолчанию, - вывод автоматически переключается на аудио-устройство, установленное в системе как основное.

6. Следующий флажок включает или выключает воспроизведение стартового звука при успешном выполнении операции.

## Сторонние компоненты
Для работы дополнение использует следующие сторонние компоненты:

* Для взаимодействия с **Windows Core Audio API** - [модуль PyCaw](https://github.com/AndreMiras/pycaw/), который распространяется под лицензией MIT.
* Для получения информации о запущенных процессах и работы компонента PyCaw - [модуль psutil](https://github.com/giampaolo/psutil), который распространяется под лицензией BSD-3.

## Журнал изменений

### Версия 1.5.6
* дополнение протестировано на совместимость с NVDA 2022.1;
* обновлен сторонний модуль **psutil**;
* дополнение адаптировано для версий Python 3.7 и 3.8;
* в исходный код добавлены MyPy аннотации типов;
* добавлена функция переключения вывода звука NVDA на аудио-устройство по умолчанию;
* настройки дополнения всегда сохраняются в базовом профиле конфигурации;
* добавлены переводы на испанский и галисийский языки (спасибо Iván Novegil Cancelas и José Manuel);
* обновлен перевод на вьетнамский язык (спасибо Dang Manh Cuong).

### Версия 1.4
* добавлен метод увеличения громкости при запуске отдельно для процесса NVDA;
* изменено звуковое оповещение об успешно выполненной операции (благодарность Manolo за сгенерированный звук);
* все функции ручного управления уровнем громкости перенесены в дополнение NVDA Volume Adjustment.

### Версия 1.3
* добавлена ​​возможность управлять уровнем громкости звука основного аудио устройства и отдельно для каждой запущенной программы;
* обновлен перевод на вьетнамский язык (спасибо Dang Manh Cuong);
* добавлен перевод на турецкий язык (благодарность Cagri Dogan);
* добавлен перевод на итальянский язык (спасибо Christianlm);
* добавлен перевод на китайский язык (спасибо Cary Rowen);
* добавлен перевод на польский язык (благодарность Stefan Banita);
* обновлен перевод на украинский язык;
* обновлено справку ReadMe.

### Версия 1.2
* переведено на использование **Core Audio Windows API** вместо **Windows Sound Manager**;
* добавлено воспроизведения звука при запуске, когда аудио успешно включено дополнением.

### Версия 1.1
* добавлено диалоговое окно с настройками приложения;
* обновленный перевод на Украинский язык.

### Версия 1.0.1
* выполняет неоднократные попытки повторно запустить драйвер синтезатора речи в случае его неудачной инициализации;
* добавлен перевод на вьетнамский язык (спасибо Dang Manh Cuong);
* добавлен перевод на Украинский язык.

### Версия 1.0: особенности реализации
В работе дополнение использует сторонний модуль Windows Sound Manager.

## Внесение изменений в исходный код дополнения
Вы можете клонировать этот репозиторий, чтобы внести изменения в NVDA Unmute.

### Дополнительные зависимости
Следующие модули можно установить с помощью pip:

- markdown
- scons
- python-gettext

### Построение дополнения из репозитория
1. Откройте командную строку, перейдите в корневой каталог этого репозитория.
2. Запустите на выполнение команду ** scons **. Если не возникло ошибок, сгенерированное дополнение будет помещено в текущий каталог.

[1]: https://addons.nvda-project.org/files/get.php?file=unmute
