# NVDA Unmute (Автоувімкнення звуку Windows)

* Автор: Олександр Грищенко
* Версія: 1.5
* Сумісність з NVDA: 2019.3 та новіші версії
* Завантажити [стабільну версію][1]

Цей додаток перевіряє стан аудіосистеми Windows під час запуску NVDA. І, якщо виявляється, що звук вимкнений або дуже приглушений, - додаток примусово вмикає його.

Одночасно перевіряється рівень гучності встановлений окремо для процесу NVDA.

Також додаток перевіряє стан синтезатора мовлення. Якщо виникли проблеми з його ініціалізацією, виконуються спроби запуску синтезатора, який вказаний в налаштуваннях NVDA.

Присутня додаткова можливість перевіряти на який аудіо-пристрій виводиться звук NVDA. І, якщо цей пристрій відрізняється від пристрою за замовчуванням, - вивід автоматично перемикається на аудіо-пристрій, що встановлений в системі як основний.

Примітка: Якщо звуковий сигнал додатку завжди відтворюється, навіть якщо рівень гучності NVDA перебуває на належному рівні. Тобто додаток перемикає виведення звуку на основний аудіо-пристрій кожного разу при запуску NVDA.

Це зазвичай відбувається, коли пристрій виведення звуку в налаштуваннях NVDA відрізняється від пристрою виводу за замовчуванням або "Microsoft Sound Mapper".

Таку поведінку можна легко змінити одним із наступних способів:

1. Після перезапуску NVDA просто збережіть поточну конфігурацію за допомогою комбінації клавіш NVDA+Ctrl+C. Аудіо-пристрій за замовчуванням буде збережено в налаштуваннях NVDA, і перемикання не відбуватиметься при кожному запуску.
2. Якщо ви не хочете змінювати конфігурацію NVDA - просто вимкніть функцію перемикання звукового пристрою в панелі налаштувань додатку.

## Діалогове вікно налаштувань додатку
Щоб відкрити панель налаштувань додатку, виконайте такі дії:

* Натисніть NVDA+N, щоб відкрити меню NVDA.
* Далі перейдіть до "Параметри" -> "Налаштування...", та у списку категорій знайдіть і відкрийте "Автоувімкнення звуку Windows".

Це все, тепер користуючись клавішею Tab ви можете переходити між параметрами додатку.

В діалоговому вікні налаштувань додатку доступні такі параметри:

1. Перший слайдер в діалоговому вікні налаштувань додатку дозволяє вказати рівень гучності звуку Windows який буде встановлено при запуску NVDA, якщо попередньо звук був вимкнений або його рівень був занадто низький.

2. Мінімальний рівень гучності Windows, при якому буде застосовуватись процедура збільшення звуку. Цей слайдер дозволяє налаштувати рівень чутливості додатку.

    Якщо рівень гучності знизиться до меншого ніж вказане тут значення, то при наступному запуску NVDA гучність буде збільшена.

    Інакше, якщо рівень гучності залишиться вищим ніж вказане тут значення, то при перезапуску NVDA його рівень змінюватись не буде.

    І, звичайно, якщо звук раніше було вимкнено, при перезапуску додаток все-одно увімкне його в будь-якому випадку.

3. Наступний прапорець дозволяє увімкнути повторну ініціалізацію драйвера голосового синтезатора.

    Ця процедура буде запускатись лише у тому випадку, коли при старті NVDA буде виявлено, що драйвер синтезатора голосу не був ініціалізований.

4. В цьому полі можна вказати кількість спроб повторної ініціалізації драйвера. Спроби виконуються циклічно з інтервалом в 1 секунду. Значення 0 означає, що спроби будуть виконуватись безкінечно аж до успішного завершення процедури.

5. Опція "Перемикати вивід звуку NVDA на аудіо-пристрій за замовчуванням" дозволяє при запуску перевірити на який аудіо-пристрій виводиться звук NVDA. І, якщо цей пристрій відрізняється від пристрою за замовчуванням, - вивід автоматично перемикається на аудіо-пристрій, що встановлений в системі як основний.

6. Наступний прапорець вмикає або вимикає відтворення стартового звуку при успішному виконанні операції.

## Сторонні компоненти
Для роботи додаток використовує наступні сторонні компоненти:

* Для взаємодії з **Windows Core Audio API** - [модуль PyCaw](https://github.com/AndreMiras/pycaw/), який розповсюджується під ліцензією MIT.
* Для отримання інформації про запущені процеси і роботи компонента PyCaw - [модуль psutil](https://github.com/giampaolo/psutil), що поширюється під ліцензією BSD-3.

## Журнал змін

### Версія 1.5.7
* додаток протестовано на сумісність з NVDA 2023.1.

### Версія 1.5.6
* додаток протестовано на сумісність з NVDA 2022.1;
* оновлено сторонній модуль **psutil**;
* додаток адаптовано для підтримки версій Python 3.7 та 3.8;
* до вихідного коду додатку додано MyPy анотації типів;
* додана функція перемикання виводу звуку NVDA на аудіо-пристрій за замовчуванням;
* налаштування додатку завжди зберігаються у базовому профілі конфігурації;
* додано переклади на іспанську та галіційську мови (подяка Iván Novegil Cancelas та José Manuel);
* оновлено переклад на в'єтнамську мову (подяка Dang Manh Cuong).

### Версія 1.4
* додано метод збільшення гучності при запуску окремо для процесу NVDA;
* змінено звукове сповіщення про успішно виконану операцію (подяка Manolo за згенерований звук);
* всі функції ручного керування рівнем гучності перенесені до додатку NVDA Volume Adjustment.

### Версія 1.3
* додана можливість керувати рівнем гучності звуку основного аудіо-пристрою та окремо для кожної запущеної програми;
* оновлено переклад на в'єтнамську мову (подяка Dang Manh Cuong);
* додано переклад на турецьку мову (подяка Cagri Dogan);
* додано переклад на італійську мову (подяка Christianlm);
* додано переклад на китайську мову (подяка Cary Rowen);
* додано переклад на польську мову (подяка Stefan Banita);
* оновлено переклад українською мовою;
* оновлено довідку ReadMe.

### Версія 1.2
* переведено на використання **Core Audio Windows API** замість **Windows Sound Manager**;
* додано відтворення звуку під час запуску, коли аудіо успішно увімкнено додатком.

### Версія 1.1
* додане діалогове вікно з налаштуваннями додатку;
* оновлений переклад українською мовою.

### Версія 1.0.1
* Виконує неодноразові спроби увімкнути драйвер синтезатора у разі його невдалої ініціалізації;
* Додано переклад на в'єтнамську мову (подяка Dang Manh Cuong);
* перекладено українською.

### Версія 1.0. Особливості реалізації
В роботі додаток використовує сторонній модуль Windows Sound Manager.

## внесення змін до вихідного коду доповнення
Ви можете клонувати цей репозиторій, щоб внести зміни до NVDA Unmute.

### Додаткові залежності
Наступні модулі можна встановити за допомогою pip:

- markdown
- scons
- python-gettext

### Підготовка додатку для розповсюдження
1. Відкрийте командний рядок, перейдіть до кореневого каталогу цього репозиторія.
2. Запустіть на виконання команду **scons**. Якщо не виникло помилок, згенерований додаток розміщується в поточному каталозі.

[1]: https://addons.nvda-project.org/files/get.php?file=unmute
